var objSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
var objWMIService;
var objWMIRegistry;

// Удаление лишней информации
function ReplaceAdv(str){
	return str.replace(/\(R\)/g, '').replace(/\(TM\)/gi, '').replace(/\(Microsoft Corporation\)/,'').replace(/Microsoft /g,'').replace(/Service Pack /,'SP').replace(/Edition /g,'').replace(/Professional/,'Pro').replace(/CPU /, '').replace(/Процессор|Processor/, '').replace(/(Express|Chipset|Controller|Graphics|Family|Model)/g, '').replace(/\s+/g, ' ').replace(/\s+$/, '').replace(/^\s+/, '');
}

function GetPCSerialNumber(i){
	aHosts[i].PCSerialNumber = '';
	try {
		var colItems = objWMIService.ExecQuery ("select * from Win32_SystemEnclosure");
		var enumItems = new Enumerator(colItems);
		for (; !enumItems.atEnd(); enumItems.moveNext()) {
			var objItem = enumItems.item();
			aHosts[i].PCSerialNumber = objItem.SerialNumber;
		}
	} catch(e) {};
}

function GetProcessorInfo(i){
	aHosts[i].proc_name = '';
	aHosts[i].proc_clock = '';
	try {
		var colItems = objWMIService.ExecQuery ("select * from Win32_Processor");
		var enumItems = new Enumerator(colItems);
		for (; !enumItems.atEnd(); enumItems.moveNext()) {
			var objItem = enumItems.item();
			aHosts[i].proc_name = ReplaceAdv(objItem.Name);
			aHosts[i].proc_clock = objItem.CurrentClockSpeed;
		}
	} catch(e) {};
}

function GetDisksSize(i){
	aHosts[i].disks_size = '';
	try {
		var colItems = objWMIService.ExecQuery ("select * from Win32_DiskDrive");
		var enumItems = new Enumerator(colItems);
		var arr_disks_size = [];
		for (; !enumItems.atEnd(); enumItems.moveNext()) {
			var objItem = enumItems.item();
			var status = objItem.Status;
			if (status != 'OK') WshShell.Popup(objItem.Caption + " S.M.A.R.T. status: " + status, 5, NameOrIp(i), 16);
			arr_disks_size[arr_disks_size.length] = Math.round(objItem.Size/1000/1000/1000);
		}
		aHosts[i].disks_size = arr_disks_size.join(", ");
	} catch(e) {};
}

function GetMemoryInfo(i){
	aHosts[i].memory_size = '';
	aHosts[i].memory_info = '';
	var aFormFactor = ['Unknown','Other','SIP','DIP','ZIP','SOJ','Proprietary','SIMM','DIMM','TSOP','PGA','RIMM','SODIMM','SRIMM','SMD','SSMP','QFP','TQFP','SOIC','LCC','PLCC','BGA','FPBGA','LGA'];
	var aMemoryType = ['Unknown','Other','DRAM','Synchronous DRAM','Cache DRAM','EDO','EDRAM','VRAM','SRAM','RAM','ROM','Flash','EEPROM','FEPROM','EPROM','CDRAM','3DRAM','SDRAM','SGRAM','RDRAM','DDR','DDR-2'];
	try {
		var colItems = objWMIService.ExecQuery ("select * from Win32_PhysicalMemory");
		var enumItems = new Enumerator(colItems);
		var arr_mem_size = [];
		var mem_speed = mem_type = mem_formfactor = '';
		for (; !enumItems.atEnd(); enumItems.moveNext()) {
			var objItem = enumItems.item();
			arr_mem_size[arr_mem_size.length] = objItem.Capacity/1024/1024;
			if (objItem.FormFactor) mem_formfactor = aFormFactor[objItem.FormFactor];
			if (objItem.MemoryType) mem_type = aMemoryType[objItem.MemoryType];
			if (objItem.Speed) mem_speed = objItem.Speed;
		}
		aHosts[i].memory_size = arr_mem_size.join("+");

		var mem_info = mem_formfactor ? mem_formfactor : '';
		mem_info += mem_type ? ' ' + mem_type : '';
		mem_info += mem_speed ? ' ' + mem_speed : '';
		aHosts[i].memory_info = mem_info;
	} catch(e) {};
}

function GetVideoProc(i){
	aHosts[i].video = '';
	aHosts[i].video_mem = '';
	try {
		var colItems = objWMIService.ExecQuery ("select * from Win32_VideoController");
		var enumItems = new Enumerator(colItems);
		for (; !enumItems.atEnd(); enumItems.moveNext()) {
			var objItem = enumItems.item();
			if (/^PCI\\/.test(objItem.PNPDeviceID)) {
				aHosts[i].video = ReplaceAdv(objItem.Name);
				aHosts[i].video_mem = Math.round(objItem.AdapterRAM/1024/1024);
			}
		}
	} catch(e) {};
}

function GetMonitors(i){
	function GetPNPDeviceID(){
		var ret = [];
		try {
			var colItems = objWMIService.ExecQuery ("SELECT * FROM Win32_PnPEntity WHERE Service='monitor'");
			var enumItems = new Enumerator(colItems);
			for (; !enumItems.atEnd(); enumItems.moveNext()) {
				var objItem = enumItems.item();
				if (objItem.DeviceID) ret.push(objItem.DeviceID);
			}
		} catch(e) {};
		return ret;
	}

	function DecodeEDIDInfo(EDID, is_model){
		var num = 0;
		for (var j = 0; j < EDID.length-4; j++) {
			if (is_model) { // Model name
				if (EDID[j] == 0 && EDID[j + 1] == 0 && EDID[j + 2] == 252 && EDID[j + 3] == 0) num = j + 3;
			} else {        // Serial number
				if (EDID[j] == 0 && EDID[j + 1] == 0 && EDID[j + 2] == 0   && EDID[j + 3] == 255 && EDID[j + 4] == 0) num = j + 4;
			}
		}
		if (num != 0) {
			var ret_string = "";
			var j = 1;
			while (j < 14 && EDID[num + j] != 10){
				ret_string += String.fromCharCode(EDID[num + j]);
				j++;
			}
			return ret_string;
		}
	}

	aHosts[i].MonitorName = '';
	aHosts[i].MonitorSerialNumber = '';
	var aPNPDeviceID = GetPNPDeviceID();
	var aMonitorName = [];
	var aMonitorSerialNumber = [];
	var monitorName, monitorSerialNumber;
	for (var n = 0; n < aPNPDeviceID.length; n++) {
		var EDID = GetRegistry('GetBinaryValue', 'HKLM', 'SYSTEM\\CurrentControlSet\\Enum\\' + aPNPDeviceID[n] + '\\Device Parameters', 'EDID');
		if (EDID) {
			if (EDID[0] == 0 && EDID[1] == 255 && EDID[2] == 255 && EDID[3] == 255 && EDID[4] == 255 && EDID[5] == 255 && EDID[6] == 255 && EDID[7] == 0) {
				monitorName = DecodeEDIDInfo(EDID, true);
				if (monitorName) aMonitorName.push(monitorName);
				monitorSerialNumber = DecodeEDIDInfo(EDID);
				if (monitorSerialNumber) aMonitorSerialNumber.push(monitorSerialNumber);
			}
		}
	}
	if (aMonitorName.length > 0) aHosts[i].MonitorName = (aMonitorName.length == 1) ? aMonitorName[0] : '[' + aMonitorName.join('|') + ']';
	if (aMonitorSerialNumber.length > 0) aHosts[i].MonitorSerialNumber = (aMonitorSerialNumber.length == 1) ? aMonitorSerialNumber[0] : '[' + aMonitorSerialNumber.join('|') + ']';
}

function GetNetInfo(i){
	aHosts[i].mac = '';
	aHosts[i].ip_all = '';
	aHosts[i].DefaultIPGateway = '';
	aHosts[i].DNSServerSearchOrder = '';
	try {
		var colItems = objWMIService.ExecQuery ("select * from Win32_NetworkAdapterConfiguration where IPEnabled = True");
		var enumItems = new Enumerator(colItems);
		var objItem = enumItems.item();
		aHosts[i].mac = objItem.MACAddress;
		try {
			var ip_address = objItem.IPAddress.toArray();
			aHosts[i].ip = ip_address[0];
			aHosts[i].ip_all = ip_address.join(",")
		} catch(e) {};
		try {aHosts[i].IPSubnet = objItem.IPSubnet.toArray().join(",")} catch(e) {};
		try {aHosts[i].DefaultIPGateway = objItem.DefaultIPGateway.toArray().join(",")} catch(e) {};
		try {aHosts[i].DNSServerSearchOrder = objItem.DNSServerSearchOrder.toArray().join(",")} catch(e) {};
	} catch(e) {};
}

function GetComputerSystem(i){
	aHosts[i].name = '';
	aHosts[i].domain = '';
	aHosts[i].username = '';
	aHosts[i].SID = '';
	try {
		var colItems = objWMIService.ExecQuery ("select * from Win32_ComputerSystem");
		var enumItems = new Enumerator(colItems);
		for (; !enumItems.atEnd(); enumItems.moveNext()) {
			var objItem = enumItems.item();
			aHosts[i].name = objItem.Name;
			aHosts[i].domain = objItem.Domain;
			var username = objItem.UserName;
			if (username) {
				aHosts[i].username = username;
				var du = username.split('\\');
				aHosts[i].user = du[1];
				aHosts[i].SID = objWMIService.Get("Win32_UserAccount.Domain='" + du[0] + "'" + ",Name='" + du[1] + "'").SID;
			}
		}
	} catch(e) {};
}

function GetPrinters(i){
	aHosts[i].Printers = '';
	var ret = [];
	var defPrinter = GetRegistry('GetStringValue', 'HKU', aHosts[i].SID + '\\Software\\Microsoft\\Windows NT\\CurrentVersion\\Windows', 'Device');
	if (defPrinter) {
		defPrinter = defPrinter.split(',')[0];
		ret.push(defPrinter);
	}
	var aPrinters = GetRegistry('EnumValues', 'HKU', aHosts[i].SID + '\\Software\\Microsoft\\Windows NT\\CurrentVersion\\PrinterPorts');
	if (aPrinters) {
		for (var j = 0; j < aPrinters.length; j++) {
			if (aPrinters[j] != defPrinter) {
				ret.push(aPrinters[j]);
			}
		}
	}
	if (ret.length > 0) aHosts[i].Printers = (ret.length == 1) ? ret[0] : '[' + ret.join('|') + ']';
}

function GetMappedDrives(i){
	aHosts[i].MappedDrives = '';
	var ret = [];
	var aDrives = GetRegistry('EnumKey', 'HKU', aHosts[i].SID + '\\Network');
	if (aDrives) {
		var letter, path;
		for (var j = 0; j < aDrives.length; j++) {
			letter = aDrives[j];
			path = GetRegistry("GetStringValue", "HKU", aHosts[i].SID + '\\Network\\' + letter, 'RemotePath');
			ret.push(letter + '=' + path);
		}
	}
	if (ret.length > 0) aHosts[i].MappedDrives = (ret.length == 1) ? ret[0] : '[' + ret.join('|') + ']';
}

function GetOperatingSystem(i){
	aHosts[i].OSVersion = '';
	try {
		var colItems = objWMIService.ExecQuery ("select * from Win32_OperatingSystem");
		var enumItems = new Enumerator(colItems);
		for (; !enumItems.atEnd(); enumItems.moveNext()) {
			var objItem = enumItems.item();
			aHosts[i].OSVersion = objItem.Caption + ' ' + objItem.Version;
			if (objItem.CSDVersion) aHosts[i].OSVersion += ' ' + objItem.CSDVersion;
			aHosts[i].OSVersion = ReplaceAdv(aHosts[i].OSVersion);
		}
	} catch(e) {};
}

function GetUserInfoFromAD(i){
	function GetLDAPstring(username) {
		var ADS_NAME_INITTYPE_GC = 3;
		var ADS_NAME_TYPE_1779 = 1;
		var ADS_NAME_TYPE_NT4  = 3;

		try {
			with (new ActiveXObject("NameTranslate")) {
				Init (ADS_NAME_INITTYPE_GC, "");
				Set (ADS_NAME_TYPE_NT4, username);
				return Get(ADS_NAME_TYPE_1779);
			}
		} catch(e) {}
	}

	if (aHosts[i].username) {
		var LDAPstring = GetLDAPstring(aHosts[i].username);
		if (LDAPstring) {
			var oUser = GetObject('LDAP://' + LDAPstring);
			if (oUser.cn) aHosts[i].user_cn = oUser.cn; // ФИО
			if (oUser.info) aHosts[i].user_info = oUser.info.replace(/^.*#/, '').replace(/\s*Центра?\s+операционной\s+поддержки\s+в\s+г\.\s*Нижнем\s+Новгороде\s*/i, ''); // отдел
			if (oUser.title) aHosts[i].user_title = oUser.title; // должность
			if (oUser.mail) aHosts[i].user_mail = oUser.mail; // e-mail
			if (oUser.telephoneNumber) aHosts[i].user_telephoneNumber = oUser.telephoneNumber; // корпоративный
			if (oUser.otherTelephone) aHosts[i].user_otherTelephone = oUser.otherTelephone; // городской
		}
	}
}

var curHost; // глобальный для того, чтобы был виден из logon.html
// Подключение к удаленному компьютеру
function ConnectServer(i) {
	function Connect(host, login, pass) {
		try {
			objWMIService  = objSWbemLocator.ConnectServer(host, "root\\CIMV2",   login, pass);
			objWMIRegistry = objSWbemLocator.ConnectServer(host, "root\\DEFAULT", login, pass).Get("StdRegProv");
			return {
				number      : 0,
				description : ''
			};
		} catch(e) {
			return {
				number      : e.number & 0xFFFF,
				description : e.description
			};
		}
	}

	curHost = NameOrIp(i);
	var connect_ret = Connect(curHost);
	if (connect_ret.number == 0) return true; // Без логина/пароля (с правами текущего пользователя)
	if (connect_ret.number == 5) { // Отказано в доступе
		if (admin_pass) {
			connect_ret = Connect(curHost, admin_name, admin_pass); // С логином/паролем администратора из INI файла
			if (connect_ret.number == 0) return true;
		}
		if (connect_ret.number == 5) { // Отказано в доступе
			var old_credentials = admin_name + admin_pass;
			// Задаём логин/пароль в диалоговом окне:
			showModalDialog('code/logon.html', self, 'status:no; help:no; dialogWidth:10px; dialogHeight:30px;');
			if (admin_name + admin_pass != old_credentials) {
				connect_ret = Connect(curHost, admin_name, admin_pass);
				if (connect_ret.number == 0) return true;
			}
		}
	}
	WshShell.Popup("Error connecting to host " + curHost + "\n" + connect_ret.number + " : " + connect_ret.description, 2, app_name, 16);
}

function NameOrIp(i) {
	return aHosts[i].ip || aHosts[i].name || aHosts[i].hostname;
}

function HostResolve(i) {
	var out_file = FSO.BuildPath(FSO.GetSpecialFolder(2), FSO.GetTempName());
	var cmd = 'cmd /c ping /a ' + NameOrIp(i) + ' -n 1 >' + out_file;
	WshShell.Run(cmd, 0, true);
	var out = ReadTextFile(out_file);
	if (FSO.FileExists(out_file)) FSO.DeleteFile(out_file, true);
	if (/(([\w\-]+)\.?([\w\-\.]*)) \[([\d\.\:]+)\]/i.test(out)) {
		aHosts[i].hostname = RegExp.$1;
		aHosts[i].name = RegExp.$2;
		aHosts[i].domain = RegExp.$3;
		aHosts[i].ip = RegExp.$4;
	}
	if ((!aHosts[i].hostname) && aHosts[i].name && aHosts[i].domain) aHosts[i].hostname = aHosts[i].name + '.' + aHosts[i].domain;
}

// Чтение информации с удаленного ПК
function GetHostInfo(i){
	var aHosts_tmp = ObjClone(aHosts[i]);
	HostResolve(i);
	if ( (IsContainArray(['computer', 'server', 'notebook'], aHosts[i].type)) && ConnectServer(i) ) {
		GetPCSerialNumber(i);
		GetComputerSystem(i);
		GetNetInfo(i);
		GetOperatingSystem(i);
		GetProcessorInfo(i);
		GetMemoryInfo(i);
		GetDisksSize(i);
		GetVideoProc(i);
		GetMonitors(i);
		GetPrinters(i);
		GetMappedDrives(i);
		GetUserInfoFromAD(i);
	}
	ObjCompare(aHosts[i], aHosts_tmp, aHosts);
	FillRow(i);
	pending--;
	if (pending==0) {
		StartTimer();
		UncheckAll();
	}
}
